/*
        Histogram calculations and interface design
*/


int colors[255];

int ii;
int lo, hi;

int R,G,B; // Red-Green-Blue

void update_histogram()
{
     for (ii = 0; ii <  256; ii++) colors[ii] = 0;

     for (ii = 0; ii <  (FRM_WIDTH*FRM_HEIGHT)/2; ii++)
     {
         // Parsing pixels: ii*2 & ii*2+1
         hi = frmBuff[2*ii];
         lo = frmBuff[2*ii+1];
         R = (lo & 0b11111000) >> 3;
         G = (lo & 0b00000111) << 3 + (hi & 0b11100000) >> 5;
         B = (hi & 0b00011111);
         
         R = R*2;
         B = B*2; // Get R,B to the same max as G.
         
         colors[ (R+G+B)/3 ] ++; // Pixel brightness is (R+G+B)/3
     }
     // Total_Pixels =  FRM_WIDTH*FRM_HEIGHT/2
     
     for (ii = 0; ii <  256; ii++) colors[ii] = (colors[ii]*200)/(FRM_WIDTH*FRM_HEIGHT);
     
}

void draw_h_arrow(int x,int y, int L)
{
     TFT_Set_Pen(CL_BLUE, 2);
     TFT_Line( x, y, x + L, y);
     TFT_Line( x+L, y, x + L/2, y + L/2);
     TFT_Line( x+L, y, x + L/2, y - L/2);
}

void draw_v_arrow(int x,int y, int L)
{
     TFT_Set_Pen(CL_BLUE, 2) ;
     TFT_Line( x, y, x, y - L);
     TFT_Line( x, y - L, x + L/2, y - L/2);
     TFT_Line( x, y - L, x - L/2, y - L/2);
}


int c;

void draw_histogram() // Drawing area > (72, 133)..(248, 205)  H = 72, W = 176
{
     for (ii = 72; ii < 249; ii++)
     {
         c = (ii - 72)/4;
         TFT_Set_Pen(CL_GRAY, 1);
         TFT_V_Line(205, 205-(colors[c]) , ii);
         TFT_Set_Pen(CL_WHITE, 1);
         TFT_V_Line(205-colors[c], 133, ii);
     }
}